import { GetFileByIdProps, File as TFile } from './types/File.types';
import { default as Item } from './utils/APIElement';
export default class File extends Item<TFile> {
    private constructor();
    static getFileById: ({ baseURL, id }: GetFileByIdProps) => Promise<File | undefined>;
    getFileContent: () => Promise<void>;
}
