var wt = Object.defineProperty;
var yt = (t, e, n) => e in t ? wt(t, e, { enumerable: !0, configurable: !0, writable: !0, value: n }) : t[e] = n;
var y = (t, e, n) => yt(t, typeof e != "symbol" ? e + "" : e, n);
const Oe = globalThis;
Oe.__sasAuthPopover = Oe.__sasAuthPopover || void 0;
function bt() {
  const t = __sasAuthPopover;
  t && (__sasAuthPopover = void 0, t.close());
}
class gt {
  constructor(e, n) {
    this._closed = !0, this._url = e, this._title = n;
  }
  open() {
    var e;
    if (this._closed = this.popup ? this.popup.closed : !0, __sasAuthPopover && __sasAuthPopover === this.popup && !this._closed) {
      (e = this.popup) === null || e === void 0 || e.focus();
      return;
    }
    const n = window.outerHeight / 2 + window.screenY - 600 / 2, s = window.outerWidth / 2 + window.screenX - 700 / 2, r = window.open(this._url, this._title, `width=700,height=600,top=${n},left=${s}`);
    r && !r.closed && (this._closed = !1, this.popup = r, __sasAuthPopover = r);
  }
  close() {
    __sasAuthPopover === this.popup && bt();
  }
}
class Et extends gt {
  _rejectPromise() {
    var e;
    this._resolutionPromise && (this._messageCb && window.removeEventListener("message", this._messageCb), clearInterval(this._intervalId), this._messageCb = void 0, this._resolutionPromise = void 0, this._resolve = void 0, (e = this._reject) === null || e === void 0 || e.call(this), this._reject = void 0);
  }
  _acceptPromise() {
    var e;
    this._resolutionPromise && (this._messageCb && window.removeEventListener("message", this._messageCb), clearInterval(this._intervalId), this._messageCb = void 0, this._resolutionPromise = void 0, this._reject = void 0, (e = this._resolve) === null || e === void 0 || e.call(this), this._resolve = void 0);
  }
  open() {
    super.open(), this._closed || (this._resolutionPromise = new Promise((e, n) => {
      this._resolve = e, this._reject = n, this._messageCb = (s) => {
        this._url.indexOf(s.origin) !== -1 && s.data && s.data.logonStatus && this._acceptPromise();
      }, window.addEventListener("message", this._messageCb), this._intervalId = window.setInterval(() => {
        var s;
        (s = this.popup) === null || s === void 0 || s.postMessage("register", "*");
      }, 250);
    }));
  }
  waitForMessage() {
    return this._resolutionPromise ? this._resolutionPromise : Promise.reject();
  }
  close() {
    super.close(), this._rejectPromise();
  }
}
function Rt(t, e) {
  const n = new Et(t, e);
  return n.open(), n.waitForMessage().then(() => n.close());
}
const ae = /* @__PURE__ */ new Map();
async function St(t) {
  if (!(await fetch(`${t}/reports/?sso_guest=true`, {
    headers: {
      Accept: "application/json",
      "X-Requested-With": "XMLHttpRequest"
    },
    credentials: "include"
  })).ok)
    throw new Error("invalid logon response");
}
class xt {
  constructor(e) {
    this._config = e, this._server = e.url, e.guest && ae.set(this._config.url, Object.assign(Object.assign({}, this._getAuthenticationInfo()), { guestEnabled: !0 }));
  }
  _getAuthenticationInfo() {
    var e;
    return (e = ae.get(this._config.url)) !== null && e !== void 0 ? e : {
      authenticated: void 0,
      guestEnabled: !1
    };
  }
  _setStoreStatus(e) {
    const n = this._getAuthenticationInfo();
    ae.set(this._config.url, Object.assign(Object.assign({}, n), { authenticated: e }));
  }
  /**
   * Checks the server endpoint to see if the user is authenticated. If there is not user session
   * and any config enabled guest, then a guest session will be created. Otherwise false will be
   * returned.
   * @returns true if authenticated
   */
  async _checkEndpoint() {
    try {
      if ((await (await fetch(`${this._server}/SASVisualAnalytics/logon/index.html`, {
        credentials: "include"
      })).text()).includes("data-report-sas-auth-success"))
        return this._setStoreStatus(!0), !0;
      throw new Error("Not authenticated.");
    } catch {
      if (this._getAuthenticationInfo().guestEnabled) {
        const n = await St(this._server).then(() => !0, () => !1);
        return this._setStoreStatus(n), n;
      }
    }
    return this._setStoreStatus(!1), !1;
  }
  /**
   * Checks to see if any user is authenticated.
   *
   * @rejects: If no user is authenticated.
   */
  async checkAuthenticated() {
    var e;
    if (!((e = this._getAuthenticationInfo().authenticated) !== null && e !== void 0 ? e : await this._checkEndpoint()))
      throw `Not authenticated on ${this._server}`;
  }
  /**
   * Launches a popup window that navigates to the authentication endpoint and allows the user to login.
   *
   * @rejects: When login fails (for example: user closes the popup).
   */
  async loginPopup() {
    return new Promise(async (e, n) => {
      try {
        await Rt(`${this._server}/SASVisualAnalytics/logon/index.html`, ""), e();
      } catch {
        n(`${this._server} failed to log in`);
      }
    });
  }
  /**
   * Makes endpoint call to end the current cookie session.
   *
   * @rejects: When logout fails.
   */
  async logout() {
    if (!(await fetch(`${this._server}/SASLogon/logout.do`, {
      credentials: "include",
      headers: {
        "X-Requested-With": "XMLHttpRequest"
      }
    })).ok)
      throw new Error("Failed to logout.");
  }
  /**
   * If `checkAuthenticated` has already been called, a cached value may be returned the next time.
   * This is done to reduce the number of potential service calls needed when making multiple API
   * calls. Calling `invalidateCache` will force `checkAuthenticated` to re-validate the next time
   * it is called. **This is not needed for most use cases.**
   */
  invalidateCache() {
    this._setStoreStatus(void 0);
  }
}
function ze(t, e) {
  return function() {
    return t.apply(e, arguments);
  };
}
const { toString: Tt } = Object.prototype, { getPrototypeOf: Se } = Object, ne = /* @__PURE__ */ ((t) => (e) => {
  const n = Tt.call(e);
  return t[n] || (t[n] = n.slice(8, -1).toLowerCase());
})(/* @__PURE__ */ Object.create(null)), C = (t) => (t = t.toLowerCase(), (e) => ne(e) === t), se = (t) => (e) => typeof e === t, { isArray: v } = Array, $ = se("undefined");
function At(t) {
  return t !== null && !$(t) && t.constructor !== null && !$(t.constructor) && k(t.constructor.isBuffer) && t.constructor.isBuffer(t);
}
const Ve = C("ArrayBuffer");
function _t(t) {
  let e;
  return typeof ArrayBuffer < "u" && ArrayBuffer.isView ? e = ArrayBuffer.isView(t) : e = t && t.buffer && Ve(t.buffer), e;
}
const Ot = se("string"), k = se("function"), We = se("number"), re = (t) => t !== null && typeof t == "object", Pt = (t) => t === !0 || t === !1, V = (t) => {
  if (ne(t) !== "object")
    return !1;
  const e = Se(t);
  return (e === null || e === Object.prototype || Object.getPrototypeOf(e) === null) && !(Symbol.toStringTag in t) && !(Symbol.iterator in t);
}, kt = C("Date"), Ct = C("File"), Lt = C("Blob"), Ut = C("FileList"), Nt = (t) => re(t) && k(t.pipe), jt = (t) => {
  let e;
  return t && (typeof FormData == "function" && t instanceof FormData || k(t.append) && ((e = ne(t)) === "formdata" || // detect form-data instance
  e === "object" && k(t.toString) && t.toString() === "[object FormData]"));
}, Ft = C("URLSearchParams"), [Bt, Dt, vt, qt] = ["ReadableStream", "Request", "Response", "Headers"].map(C), It = (t) => t.trim ? t.trim() : t.replace(/^[\s\uFEFF\xA0]+|[\s\uFEFF\xA0]+$/g, "");
function M(t, e, { allOwnKeys: n = !1 } = {}) {
  if (t === null || typeof t > "u")
    return;
  let s, r;
  if (typeof t != "object" && (t = [t]), v(t))
    for (s = 0, r = t.length; s < r; s++)
      e.call(null, t[s], s, t);
  else {
    const o = n ? Object.getOwnPropertyNames(t) : Object.keys(t), i = o.length;
    let a;
    for (s = 0; s < i; s++)
      a = o[s], e.call(null, t[a], a, t);
  }
}
function Ke(t, e) {
  e = e.toLowerCase();
  const n = Object.keys(t);
  let s = n.length, r;
  for (; s-- > 0; )
    if (r = n[s], e === r.toLowerCase())
      return r;
  return null;
}
const F = typeof globalThis < "u" ? globalThis : typeof self < "u" ? self : typeof window < "u" ? window : global, Ge = (t) => !$(t) && t !== F;
function de() {
  const { caseless: t } = Ge(this) && this || {}, e = {}, n = (s, r) => {
    const o = t && Ke(e, r) || r;
    V(e[o]) && V(s) ? e[o] = de(e[o], s) : V(s) ? e[o] = de({}, s) : v(s) ? e[o] = s.slice() : e[o] = s;
  };
  for (let s = 0, r = arguments.length; s < r; s++)
    arguments[s] && M(arguments[s], n);
  return e;
}
const $t = (t, e, n, { allOwnKeys: s } = {}) => (M(e, (r, o) => {
  n && k(r) ? t[o] = ze(r, n) : t[o] = r;
}, { allOwnKeys: s }), t), Mt = (t) => (t.charCodeAt(0) === 65279 && (t = t.slice(1)), t), Ht = (t, e, n, s) => {
  t.prototype = Object.create(e.prototype, s), t.prototype.constructor = t, Object.defineProperty(t, "super", {
    value: e.prototype
  }), n && Object.assign(t.prototype, n);
}, Jt = (t, e, n, s) => {
  let r, o, i;
  const a = {};
  if (e = e || {}, t == null) return e;
  do {
    for (r = Object.getOwnPropertyNames(t), o = r.length; o-- > 0; )
      i = r[o], (!s || s(i, t, e)) && !a[i] && (e[i] = t[i], a[i] = !0);
    t = n !== !1 && Se(t);
  } while (t && (!n || n(t, e)) && t !== Object.prototype);
  return e;
}, zt = (t, e, n) => {
  t = String(t), (n === void 0 || n > t.length) && (n = t.length), n -= e.length;
  const s = t.indexOf(e, n);
  return s !== -1 && s === n;
}, Vt = (t) => {
  if (!t) return null;
  if (v(t)) return t;
  let e = t.length;
  if (!We(e)) return null;
  const n = new Array(e);
  for (; e-- > 0; )
    n[e] = t[e];
  return n;
}, Wt = /* @__PURE__ */ ((t) => (e) => t && e instanceof t)(typeof Uint8Array < "u" && Se(Uint8Array)), Kt = (t, e) => {
  const s = (t && t[Symbol.iterator]).call(t);
  let r;
  for (; (r = s.next()) && !r.done; ) {
    const o = r.value;
    e.call(t, o[0], o[1]);
  }
}, Gt = (t, e) => {
  let n;
  const s = [];
  for (; (n = t.exec(e)) !== null; )
    s.push(n);
  return s;
}, Xt = C("HTMLFormElement"), Qt = (t) => t.toLowerCase().replace(
  /[-_\s]([a-z\d])(\w*)/g,
  function(n, s, r) {
    return s.toUpperCase() + r;
  }
), Pe = (({ hasOwnProperty: t }) => (e, n) => t.call(e, n))(Object.prototype), Zt = C("RegExp"), Xe = (t, e) => {
  const n = Object.getOwnPropertyDescriptors(t), s = {};
  M(n, (r, o) => {
    let i;
    (i = e(r, o, t)) !== !1 && (s[o] = i || r);
  }), Object.defineProperties(t, s);
}, Yt = (t) => {
  Xe(t, (e, n) => {
    if (k(t) && ["arguments", "caller", "callee"].indexOf(n) !== -1)
      return !1;
    const s = t[n];
    if (k(s)) {
      if (e.enumerable = !1, "writable" in e) {
        e.writable = !1;
        return;
      }
      e.set || (e.set = () => {
        throw Error("Can not rewrite read-only method '" + n + "'");
      });
    }
  });
}, en = (t, e) => {
  const n = {}, s = (r) => {
    r.forEach((o) => {
      n[o] = !0;
    });
  };
  return v(t) ? s(t) : s(String(t).split(e)), n;
}, tn = () => {
}, nn = (t, e) => t != null && Number.isFinite(t = +t) ? t : e, ce = "abcdefghijklmnopqrstuvwxyz", ke = "0123456789", Qe = {
  DIGIT: ke,
  ALPHA: ce,
  ALPHA_DIGIT: ce + ce.toUpperCase() + ke
}, sn = (t = 16, e = Qe.ALPHA_DIGIT) => {
  let n = "";
  const { length: s } = e;
  for (; t--; )
    n += e[Math.random() * s | 0];
  return n;
};
function rn(t) {
  return !!(t && k(t.append) && t[Symbol.toStringTag] === "FormData" && t[Symbol.iterator]);
}
const on = (t) => {
  const e = new Array(10), n = (s, r) => {
    if (re(s)) {
      if (e.indexOf(s) >= 0)
        return;
      if (!("toJSON" in s)) {
        e[r] = s;
        const o = v(s) ? [] : {};
        return M(s, (i, a) => {
          const u = n(i, r + 1);
          !$(u) && (o[a] = u);
        }), e[r] = void 0, o;
      }
    }
    return s;
  };
  return n(t, 0);
}, an = C("AsyncFunction"), cn = (t) => t && (re(t) || k(t)) && k(t.then) && k(t.catch), Ze = ((t, e) => t ? setImmediate : e ? ((n, s) => (F.addEventListener("message", ({ source: r, data: o }) => {
  r === F && o === n && s.length && s.shift()();
}, !1), (r) => {
  s.push(r), F.postMessage(n, "*");
}))(`axios@${Math.random()}`, []) : (n) => setTimeout(n))(
  typeof setImmediate == "function",
  k(F.postMessage)
), ln = typeof queueMicrotask < "u" ? queueMicrotask.bind(F) : typeof process < "u" && process.nextTick || Ze, c = {
  isArray: v,
  isArrayBuffer: Ve,
  isBuffer: At,
  isFormData: jt,
  isArrayBufferView: _t,
  isString: Ot,
  isNumber: We,
  isBoolean: Pt,
  isObject: re,
  isPlainObject: V,
  isReadableStream: Bt,
  isRequest: Dt,
  isResponse: vt,
  isHeaders: qt,
  isUndefined: $,
  isDate: kt,
  isFile: Ct,
  isBlob: Lt,
  isRegExp: Zt,
  isFunction: k,
  isStream: Nt,
  isURLSearchParams: Ft,
  isTypedArray: Wt,
  isFileList: Ut,
  forEach: M,
  merge: de,
  extend: $t,
  trim: It,
  stripBOM: Mt,
  inherits: Ht,
  toFlatObject: Jt,
  kindOf: ne,
  kindOfTest: C,
  endsWith: zt,
  toArray: Vt,
  forEachEntry: Kt,
  matchAll: Gt,
  isHTMLForm: Xt,
  hasOwnProperty: Pe,
  hasOwnProp: Pe,
  // an alias to avoid ESLint no-prototype-builtins detection
  reduceDescriptors: Xe,
  freezeMethods: Yt,
  toObjectSet: en,
  toCamelCase: Qt,
  noop: tn,
  toFiniteNumber: nn,
  findKey: Ke,
  global: F,
  isContextDefined: Ge,
  ALPHABET: Qe,
  generateString: sn,
  isSpecCompliantForm: rn,
  toJSONObject: on,
  isAsyncFn: an,
  isThenable: cn,
  setImmediate: Ze,
  asap: ln
};
function m(t, e, n, s, r) {
  Error.call(this), Error.captureStackTrace ? Error.captureStackTrace(this, this.constructor) : this.stack = new Error().stack, this.message = t, this.name = "AxiosError", e && (this.code = e), n && (this.config = n), s && (this.request = s), r && (this.response = r, this.status = r.status ? r.status : null);
}
c.inherits(m, Error, {
  toJSON: function() {
    return {
      // Standard
      message: this.message,
      name: this.name,
      // Microsoft
      description: this.description,
      number: this.number,
      // Mozilla
      fileName: this.fileName,
      lineNumber: this.lineNumber,
      columnNumber: this.columnNumber,
      stack: this.stack,
      // Axios
      config: c.toJSONObject(this.config),
      code: this.code,
      status: this.status
    };
  }
});
const Ye = m.prototype, et = {};
[
  "ERR_BAD_OPTION_VALUE",
  "ERR_BAD_OPTION",
  "ECONNABORTED",
  "ETIMEDOUT",
  "ERR_NETWORK",
  "ERR_FR_TOO_MANY_REDIRECTS",
  "ERR_DEPRECATED",
  "ERR_BAD_RESPONSE",
  "ERR_BAD_REQUEST",
  "ERR_CANCELED",
  "ERR_NOT_SUPPORT",
  "ERR_INVALID_URL"
  // eslint-disable-next-line func-names
].forEach((t) => {
  et[t] = { value: t };
});
Object.defineProperties(m, et);
Object.defineProperty(Ye, "isAxiosError", { value: !0 });
m.from = (t, e, n, s, r, o) => {
  const i = Object.create(Ye);
  return c.toFlatObject(t, i, function(u) {
    return u !== Error.prototype;
  }, (a) => a !== "isAxiosError"), m.call(i, t.message, e, n, s, r), i.cause = t, i.name = t.name, o && Object.assign(i, o), i;
};
const un = null;
function he(t) {
  return c.isPlainObject(t) || c.isArray(t);
}
function tt(t) {
  return c.endsWith(t, "[]") ? t.slice(0, -2) : t;
}
function Ce(t, e, n) {
  return t ? t.concat(e).map(function(r, o) {
    return r = tt(r), !n && o ? "[" + r + "]" : r;
  }).join(n ? "." : "") : e;
}
function fn(t) {
  return c.isArray(t) && !t.some(he);
}
const dn = c.toFlatObject(c, {}, null, function(e) {
  return /^is[A-Z]/.test(e);
});
function oe(t, e, n) {
  if (!c.isObject(t))
    throw new TypeError("target must be an object");
  e = e || new FormData(), n = c.toFlatObject(n, {
    metaTokens: !0,
    dots: !1,
    indexes: !1
  }, !1, function(w, p) {
    return !c.isUndefined(p[w]);
  });
  const s = n.metaTokens, r = n.visitor || f, o = n.dots, i = n.indexes, u = (n.Blob || typeof Blob < "u" && Blob) && c.isSpecCompliantForm(e);
  if (!c.isFunction(r))
    throw new TypeError("visitor must be a function");
  function l(h) {
    if (h === null) return "";
    if (c.isDate(h))
      return h.toISOString();
    if (!u && c.isBlob(h))
      throw new m("Blob is not supported. Use a Buffer instead.");
    return c.isArrayBuffer(h) || c.isTypedArray(h) ? u && typeof Blob == "function" ? new Blob([h]) : Buffer.from(h) : h;
  }
  function f(h, w, p) {
    let R = h;
    if (h && !p && typeof h == "object") {
      if (c.endsWith(w, "{}"))
        w = s ? w : w.slice(0, -2), h = JSON.stringify(h);
      else if (c.isArray(h) && fn(h) || (c.isFileList(h) || c.endsWith(w, "[]")) && (R = c.toArray(h)))
        return w = tt(w), R.forEach(function(A, L) {
          !(c.isUndefined(A) || A === null) && e.append(
            // eslint-disable-next-line no-nested-ternary
            i === !0 ? Ce([w], L, o) : i === null ? w : w + "[]",
            l(A)
          );
        }), !1;
    }
    return he(h) ? !0 : (e.append(Ce(p, w, o), l(h)), !1);
  }
  const d = [], b = Object.assign(dn, {
    defaultVisitor: f,
    convertValue: l,
    isVisitable: he
  });
  function E(h, w) {
    if (!c.isUndefined(h)) {
      if (d.indexOf(h) !== -1)
        throw Error("Circular reference detected in " + w.join("."));
      d.push(h), c.forEach(h, function(R, T) {
        (!(c.isUndefined(R) || R === null) && r.call(
          e,
          R,
          c.isString(T) ? T.trim() : T,
          w,
          b
        )) === !0 && E(R, w ? w.concat(T) : [T]);
      }), d.pop();
    }
  }
  if (!c.isObject(t))
    throw new TypeError("data must be an object");
  return E(t), e;
}
function Le(t) {
  const e = {
    "!": "%21",
    "'": "%27",
    "(": "%28",
    ")": "%29",
    "~": "%7E",
    "%20": "+",
    "%00": "\0"
  };
  return encodeURIComponent(t).replace(/[!'()~]|%20|%00/g, function(s) {
    return e[s];
  });
}
function xe(t, e) {
  this._pairs = [], t && oe(t, this, e);
}
const nt = xe.prototype;
nt.append = function(e, n) {
  this._pairs.push([e, n]);
};
nt.toString = function(e) {
  const n = e ? function(s) {
    return e.call(this, s, Le);
  } : Le;
  return this._pairs.map(function(r) {
    return n(r[0]) + "=" + n(r[1]);
  }, "").join("&");
};
function hn(t) {
  return encodeURIComponent(t).replace(/%3A/gi, ":").replace(/%24/g, "$").replace(/%2C/gi, ",").replace(/%20/g, "+").replace(/%5B/gi, "[").replace(/%5D/gi, "]");
}
function st(t, e, n) {
  if (!e)
    return t;
  const s = n && n.encode || hn, r = n && n.serialize;
  let o;
  if (r ? o = r(e, n) : o = c.isURLSearchParams(e) ? e.toString() : new xe(e, n).toString(s), o) {
    const i = t.indexOf("#");
    i !== -1 && (t = t.slice(0, i)), t += (t.indexOf("?") === -1 ? "?" : "&") + o;
  }
  return t;
}
class Ue {
  constructor() {
    this.handlers = [];
  }
  /**
   * Add a new interceptor to the stack
   *
   * @param {Function} fulfilled The function to handle `then` for a `Promise`
   * @param {Function} rejected The function to handle `reject` for a `Promise`
   *
   * @return {Number} An ID used to remove interceptor later
   */
  use(e, n, s) {
    return this.handlers.push({
      fulfilled: e,
      rejected: n,
      synchronous: s ? s.synchronous : !1,
      runWhen: s ? s.runWhen : null
    }), this.handlers.length - 1;
  }
  /**
   * Remove an interceptor from the stack
   *
   * @param {Number} id The ID that was returned by `use`
   *
   * @returns {Boolean} `true` if the interceptor was removed, `false` otherwise
   */
  eject(e) {
    this.handlers[e] && (this.handlers[e] = null);
  }
  /**
   * Clear all interceptors from the stack
   *
   * @returns {void}
   */
  clear() {
    this.handlers && (this.handlers = []);
  }
  /**
   * Iterate over all the registered interceptors
   *
   * This method is particularly useful for skipping over any
   * interceptors that may have become `null` calling `eject`.
   *
   * @param {Function} fn The function to call for each interceptor
   *
   * @returns {void}
   */
  forEach(e) {
    c.forEach(this.handlers, function(s) {
      s !== null && e(s);
    });
  }
}
const rt = {
  silentJSONParsing: !0,
  forcedJSONParsing: !0,
  clarifyTimeoutError: !1
}, pn = typeof URLSearchParams < "u" ? URLSearchParams : xe, mn = typeof FormData < "u" ? FormData : null, wn = typeof Blob < "u" ? Blob : null, yn = {
  isBrowser: !0,
  classes: {
    URLSearchParams: pn,
    FormData: mn,
    Blob: wn
  },
  protocols: ["http", "https", "file", "blob", "url", "data"]
}, Te = typeof window < "u" && typeof document < "u", pe = typeof navigator == "object" && navigator || void 0, bn = Te && (!pe || ["ReactNative", "NativeScript", "NS"].indexOf(pe.product) < 0), gn = typeof WorkerGlobalScope < "u" && // eslint-disable-next-line no-undef
self instanceof WorkerGlobalScope && typeof self.importScripts == "function", En = Te && window.location.href || "http://localhost", Rn = /* @__PURE__ */ Object.freeze(/* @__PURE__ */ Object.defineProperty({
  __proto__: null,
  hasBrowserEnv: Te,
  hasStandardBrowserEnv: bn,
  hasStandardBrowserWebWorkerEnv: gn,
  navigator: pe,
  origin: En
}, Symbol.toStringTag, { value: "Module" })), O = {
  ...Rn,
  ...yn
};
function Sn(t, e) {
  return oe(t, new O.classes.URLSearchParams(), Object.assign({
    visitor: function(n, s, r, o) {
      return O.isNode && c.isBuffer(n) ? (this.append(s, n.toString("base64")), !1) : o.defaultVisitor.apply(this, arguments);
    }
  }, e));
}
function xn(t) {
  return c.matchAll(/\w+|\[(\w*)]/g, t).map((e) => e[0] === "[]" ? "" : e[1] || e[0]);
}
function Tn(t) {
  const e = {}, n = Object.keys(t);
  let s;
  const r = n.length;
  let o;
  for (s = 0; s < r; s++)
    o = n[s], e[o] = t[o];
  return e;
}
function ot(t) {
  function e(n, s, r, o) {
    let i = n[o++];
    if (i === "__proto__") return !0;
    const a = Number.isFinite(+i), u = o >= n.length;
    return i = !i && c.isArray(r) ? r.length : i, u ? (c.hasOwnProp(r, i) ? r[i] = [r[i], s] : r[i] = s, !a) : ((!r[i] || !c.isObject(r[i])) && (r[i] = []), e(n, s, r[i], o) && c.isArray(r[i]) && (r[i] = Tn(r[i])), !a);
  }
  if (c.isFormData(t) && c.isFunction(t.entries)) {
    const n = {};
    return c.forEachEntry(t, (s, r) => {
      e(xn(s), r, n, 0);
    }), n;
  }
  return null;
}
function An(t, e, n) {
  if (c.isString(t))
    try {
      return (e || JSON.parse)(t), c.trim(t);
    } catch (s) {
      if (s.name !== "SyntaxError")
        throw s;
    }
  return (0, JSON.stringify)(t);
}
const H = {
  transitional: rt,
  adapter: ["xhr", "http", "fetch"],
  transformRequest: [function(e, n) {
    const s = n.getContentType() || "", r = s.indexOf("application/json") > -1, o = c.isObject(e);
    if (o && c.isHTMLForm(e) && (e = new FormData(e)), c.isFormData(e))
      return r ? JSON.stringify(ot(e)) : e;
    if (c.isArrayBuffer(e) || c.isBuffer(e) || c.isStream(e) || c.isFile(e) || c.isBlob(e) || c.isReadableStream(e))
      return e;
    if (c.isArrayBufferView(e))
      return e.buffer;
    if (c.isURLSearchParams(e))
      return n.setContentType("application/x-www-form-urlencoded;charset=utf-8", !1), e.toString();
    let a;
    if (o) {
      if (s.indexOf("application/x-www-form-urlencoded") > -1)
        return Sn(e, this.formSerializer).toString();
      if ((a = c.isFileList(e)) || s.indexOf("multipart/form-data") > -1) {
        const u = this.env && this.env.FormData;
        return oe(
          a ? { "files[]": e } : e,
          u && new u(),
          this.formSerializer
        );
      }
    }
    return o || r ? (n.setContentType("application/json", !1), An(e)) : e;
  }],
  transformResponse: [function(e) {
    const n = this.transitional || H.transitional, s = n && n.forcedJSONParsing, r = this.responseType === "json";
    if (c.isResponse(e) || c.isReadableStream(e))
      return e;
    if (e && c.isString(e) && (s && !this.responseType || r)) {
      const i = !(n && n.silentJSONParsing) && r;
      try {
        return JSON.parse(e);
      } catch (a) {
        if (i)
          throw a.name === "SyntaxError" ? m.from(a, m.ERR_BAD_RESPONSE, this, null, this.response) : a;
      }
    }
    return e;
  }],
  /**
   * A timeout in milliseconds to abort a request. If set to 0 (default) a
   * timeout is not created.
   */
  timeout: 0,
  xsrfCookieName: "XSRF-TOKEN",
  xsrfHeaderName: "X-XSRF-TOKEN",
  maxContentLength: -1,
  maxBodyLength: -1,
  env: {
    FormData: O.classes.FormData,
    Blob: O.classes.Blob
  },
  validateStatus: function(e) {
    return e >= 200 && e < 300;
  },
  headers: {
    common: {
      Accept: "application/json, text/plain, */*",
      "Content-Type": void 0
    }
  }
};
c.forEach(["delete", "get", "head", "post", "put", "patch"], (t) => {
  H.headers[t] = {};
});
const _n = c.toObjectSet([
  "age",
  "authorization",
  "content-length",
  "content-type",
  "etag",
  "expires",
  "from",
  "host",
  "if-modified-since",
  "if-unmodified-since",
  "last-modified",
  "location",
  "max-forwards",
  "proxy-authorization",
  "referer",
  "retry-after",
  "user-agent"
]), On = (t) => {
  const e = {};
  let n, s, r;
  return t && t.split(`
`).forEach(function(i) {
    r = i.indexOf(":"), n = i.substring(0, r).trim().toLowerCase(), s = i.substring(r + 1).trim(), !(!n || e[n] && _n[n]) && (n === "set-cookie" ? e[n] ? e[n].push(s) : e[n] = [s] : e[n] = e[n] ? e[n] + ", " + s : s);
  }), e;
}, Ne = Symbol("internals");
function I(t) {
  return t && String(t).trim().toLowerCase();
}
function W(t) {
  return t === !1 || t == null ? t : c.isArray(t) ? t.map(W) : String(t);
}
function Pn(t) {
  const e = /* @__PURE__ */ Object.create(null), n = /([^\s,;=]+)\s*(?:=\s*([^,;]+))?/g;
  let s;
  for (; s = n.exec(t); )
    e[s[1]] = s[2];
  return e;
}
const kn = (t) => /^[-_a-zA-Z0-9^`|~,!#$%&'*+.]+$/.test(t.trim());
function le(t, e, n, s, r) {
  if (c.isFunction(s))
    return s.call(this, e, n);
  if (r && (e = n), !!c.isString(e)) {
    if (c.isString(s))
      return e.indexOf(s) !== -1;
    if (c.isRegExp(s))
      return s.test(e);
  }
}
function Cn(t) {
  return t.trim().toLowerCase().replace(/([a-z\d])(\w*)/g, (e, n, s) => n.toUpperCase() + s);
}
function Ln(t, e) {
  const n = c.toCamelCase(" " + e);
  ["get", "set", "has"].forEach((s) => {
    Object.defineProperty(t, s + n, {
      value: function(r, o, i) {
        return this[s].call(this, e, r, o, i);
      },
      configurable: !0
    });
  });
}
let P = class {
  constructor(e) {
    e && this.set(e);
  }
  set(e, n, s) {
    const r = this;
    function o(a, u, l) {
      const f = I(u);
      if (!f)
        throw new Error("header name must be a non-empty string");
      const d = c.findKey(r, f);
      (!d || r[d] === void 0 || l === !0 || l === void 0 && r[d] !== !1) && (r[d || u] = W(a));
    }
    const i = (a, u) => c.forEach(a, (l, f) => o(l, f, u));
    if (c.isPlainObject(e) || e instanceof this.constructor)
      i(e, n);
    else if (c.isString(e) && (e = e.trim()) && !kn(e))
      i(On(e), n);
    else if (c.isHeaders(e))
      for (const [a, u] of e.entries())
        o(u, a, s);
    else
      e != null && o(n, e, s);
    return this;
  }
  get(e, n) {
    if (e = I(e), e) {
      const s = c.findKey(this, e);
      if (s) {
        const r = this[s];
        if (!n)
          return r;
        if (n === !0)
          return Pn(r);
        if (c.isFunction(n))
          return n.call(this, r, s);
        if (c.isRegExp(n))
          return n.exec(r);
        throw new TypeError("parser must be boolean|regexp|function");
      }
    }
  }
  has(e, n) {
    if (e = I(e), e) {
      const s = c.findKey(this, e);
      return !!(s && this[s] !== void 0 && (!n || le(this, this[s], s, n)));
    }
    return !1;
  }
  delete(e, n) {
    const s = this;
    let r = !1;
    function o(i) {
      if (i = I(i), i) {
        const a = c.findKey(s, i);
        a && (!n || le(s, s[a], a, n)) && (delete s[a], r = !0);
      }
    }
    return c.isArray(e) ? e.forEach(o) : o(e), r;
  }
  clear(e) {
    const n = Object.keys(this);
    let s = n.length, r = !1;
    for (; s--; ) {
      const o = n[s];
      (!e || le(this, this[o], o, e, !0)) && (delete this[o], r = !0);
    }
    return r;
  }
  normalize(e) {
    const n = this, s = {};
    return c.forEach(this, (r, o) => {
      const i = c.findKey(s, o);
      if (i) {
        n[i] = W(r), delete n[o];
        return;
      }
      const a = e ? Cn(o) : String(o).trim();
      a !== o && delete n[o], n[a] = W(r), s[a] = !0;
    }), this;
  }
  concat(...e) {
    return this.constructor.concat(this, ...e);
  }
  toJSON(e) {
    const n = /* @__PURE__ */ Object.create(null);
    return c.forEach(this, (s, r) => {
      s != null && s !== !1 && (n[r] = e && c.isArray(s) ? s.join(", ") : s);
    }), n;
  }
  [Symbol.iterator]() {
    return Object.entries(this.toJSON())[Symbol.iterator]();
  }
  toString() {
    return Object.entries(this.toJSON()).map(([e, n]) => e + ": " + n).join(`
`);
  }
  get [Symbol.toStringTag]() {
    return "AxiosHeaders";
  }
  static from(e) {
    return e instanceof this ? e : new this(e);
  }
  static concat(e, ...n) {
    const s = new this(e);
    return n.forEach((r) => s.set(r)), s;
  }
  static accessor(e) {
    const s = (this[Ne] = this[Ne] = {
      accessors: {}
    }).accessors, r = this.prototype;
    function o(i) {
      const a = I(i);
      s[a] || (Ln(r, i), s[a] = !0);
    }
    return c.isArray(e) ? e.forEach(o) : o(e), this;
  }
};
P.accessor(["Content-Type", "Content-Length", "Accept", "Accept-Encoding", "User-Agent", "Authorization"]);
c.reduceDescriptors(P.prototype, ({ value: t }, e) => {
  let n = e[0].toUpperCase() + e.slice(1);
  return {
    get: () => t,
    set(s) {
      this[n] = s;
    }
  };
});
c.freezeMethods(P);
function ue(t, e) {
  const n = this || H, s = e || n, r = P.from(s.headers);
  let o = s.data;
  return c.forEach(t, function(a) {
    o = a.call(n, o, r.normalize(), e ? e.status : void 0);
  }), r.normalize(), o;
}
function it(t) {
  return !!(t && t.__CANCEL__);
}
function q(t, e, n) {
  m.call(this, t ?? "canceled", m.ERR_CANCELED, e, n), this.name = "CanceledError";
}
c.inherits(q, m, {
  __CANCEL__: !0
});
function at(t, e, n) {
  const s = n.config.validateStatus;
  !n.status || !s || s(n.status) ? t(n) : e(new m(
    "Request failed with status code " + n.status,
    [m.ERR_BAD_REQUEST, m.ERR_BAD_RESPONSE][Math.floor(n.status / 100) - 4],
    n.config,
    n.request,
    n
  ));
}
function Un(t) {
  const e = /^([-+\w]{1,25})(:?\/\/|:)/.exec(t);
  return e && e[1] || "";
}
function Nn(t, e) {
  t = t || 10;
  const n = new Array(t), s = new Array(t);
  let r = 0, o = 0, i;
  return e = e !== void 0 ? e : 1e3, function(u) {
    const l = Date.now(), f = s[o];
    i || (i = l), n[r] = u, s[r] = l;
    let d = o, b = 0;
    for (; d !== r; )
      b += n[d++], d = d % t;
    if (r = (r + 1) % t, r === o && (o = (o + 1) % t), l - i < e)
      return;
    const E = f && l - f;
    return E ? Math.round(b * 1e3 / E) : void 0;
  };
}
function jn(t, e) {
  let n = 0, s = 1e3 / e, r, o;
  const i = (l, f = Date.now()) => {
    n = f, r = null, o && (clearTimeout(o), o = null), t.apply(null, l);
  };
  return [(...l) => {
    const f = Date.now(), d = f - n;
    d >= s ? i(l, f) : (r = l, o || (o = setTimeout(() => {
      o = null, i(r);
    }, s - d)));
  }, () => r && i(r)];
}
const G = (t, e, n = 3) => {
  let s = 0;
  const r = Nn(50, 250);
  return jn((o) => {
    const i = o.loaded, a = o.lengthComputable ? o.total : void 0, u = i - s, l = r(u), f = i <= a;
    s = i;
    const d = {
      loaded: i,
      total: a,
      progress: a ? i / a : void 0,
      bytes: u,
      rate: l || void 0,
      estimated: l && a && f ? (a - i) / l : void 0,
      event: o,
      lengthComputable: a != null,
      [e ? "download" : "upload"]: !0
    };
    t(d);
  }, n);
}, je = (t, e) => {
  const n = t != null;
  return [(s) => e[0]({
    lengthComputable: n,
    total: t,
    loaded: s
  }), e[1]];
}, Fe = (t) => (...e) => c.asap(() => t(...e)), Fn = O.hasStandardBrowserEnv ? (
  // Standard browser envs have full support of the APIs needed to test
  // whether the request URL is of the same origin as current location.
  function() {
    const e = O.navigator && /(msie|trident)/i.test(O.navigator.userAgent), n = document.createElement("a");
    let s;
    function r(o) {
      let i = o;
      return e && (n.setAttribute("href", i), i = n.href), n.setAttribute("href", i), {
        href: n.href,
        protocol: n.protocol ? n.protocol.replace(/:$/, "") : "",
        host: n.host,
        search: n.search ? n.search.replace(/^\?/, "") : "",
        hash: n.hash ? n.hash.replace(/^#/, "") : "",
        hostname: n.hostname,
        port: n.port,
        pathname: n.pathname.charAt(0) === "/" ? n.pathname : "/" + n.pathname
      };
    }
    return s = r(window.location.href), function(i) {
      const a = c.isString(i) ? r(i) : i;
      return a.protocol === s.protocol && a.host === s.host;
    };
  }()
) : (
  // Non standard browser envs (web workers, react-native) lack needed support.
  /* @__PURE__ */ function() {
    return function() {
      return !0;
    };
  }()
), Bn = O.hasStandardBrowserEnv ? (
  // Standard browser envs support document.cookie
  {
    write(t, e, n, s, r, o) {
      const i = [t + "=" + encodeURIComponent(e)];
      c.isNumber(n) && i.push("expires=" + new Date(n).toGMTString()), c.isString(s) && i.push("path=" + s), c.isString(r) && i.push("domain=" + r), o === !0 && i.push("secure"), document.cookie = i.join("; ");
    },
    read(t) {
      const e = document.cookie.match(new RegExp("(^|;\\s*)(" + t + ")=([^;]*)"));
      return e ? decodeURIComponent(e[3]) : null;
    },
    remove(t) {
      this.write(t, "", Date.now() - 864e5);
    }
  }
) : (
  // Non-standard browser env (web workers, react-native) lack needed support.
  {
    write() {
    },
    read() {
      return null;
    },
    remove() {
    }
  }
);
function Dn(t) {
  return /^([a-z][a-z\d+\-.]*:)?\/\//i.test(t);
}
function vn(t, e) {
  return e ? t.replace(/\/?\/$/, "") + "/" + e.replace(/^\/+/, "") : t;
}
function ct(t, e) {
  return t && !Dn(e) ? vn(t, e) : e;
}
const Be = (t) => t instanceof P ? { ...t } : t;
function D(t, e) {
  e = e || {};
  const n = {};
  function s(l, f, d) {
    return c.isPlainObject(l) && c.isPlainObject(f) ? c.merge.call({ caseless: d }, l, f) : c.isPlainObject(f) ? c.merge({}, f) : c.isArray(f) ? f.slice() : f;
  }
  function r(l, f, d) {
    if (c.isUndefined(f)) {
      if (!c.isUndefined(l))
        return s(void 0, l, d);
    } else return s(l, f, d);
  }
  function o(l, f) {
    if (!c.isUndefined(f))
      return s(void 0, f);
  }
  function i(l, f) {
    if (c.isUndefined(f)) {
      if (!c.isUndefined(l))
        return s(void 0, l);
    } else return s(void 0, f);
  }
  function a(l, f, d) {
    if (d in e)
      return s(l, f);
    if (d in t)
      return s(void 0, l);
  }
  const u = {
    url: o,
    method: o,
    data: o,
    baseURL: i,
    transformRequest: i,
    transformResponse: i,
    paramsSerializer: i,
    timeout: i,
    timeoutMessage: i,
    withCredentials: i,
    withXSRFToken: i,
    adapter: i,
    responseType: i,
    xsrfCookieName: i,
    xsrfHeaderName: i,
    onUploadProgress: i,
    onDownloadProgress: i,
    decompress: i,
    maxContentLength: i,
    maxBodyLength: i,
    beforeRedirect: i,
    transport: i,
    httpAgent: i,
    httpsAgent: i,
    cancelToken: i,
    socketPath: i,
    responseEncoding: i,
    validateStatus: a,
    headers: (l, f) => r(Be(l), Be(f), !0)
  };
  return c.forEach(Object.keys(Object.assign({}, t, e)), function(f) {
    const d = u[f] || r, b = d(t[f], e[f], f);
    c.isUndefined(b) && d !== a || (n[f] = b);
  }), n;
}
const lt = (t) => {
  const e = D({}, t);
  let { data: n, withXSRFToken: s, xsrfHeaderName: r, xsrfCookieName: o, headers: i, auth: a } = e;
  e.headers = i = P.from(i), e.url = st(ct(e.baseURL, e.url), t.params, t.paramsSerializer), a && i.set(
    "Authorization",
    "Basic " + btoa((a.username || "") + ":" + (a.password ? unescape(encodeURIComponent(a.password)) : ""))
  );
  let u;
  if (c.isFormData(n)) {
    if (O.hasStandardBrowserEnv || O.hasStandardBrowserWebWorkerEnv)
      i.setContentType(void 0);
    else if ((u = i.getContentType()) !== !1) {
      const [l, ...f] = u ? u.split(";").map((d) => d.trim()).filter(Boolean) : [];
      i.setContentType([l || "multipart/form-data", ...f].join("; "));
    }
  }
  if (O.hasStandardBrowserEnv && (s && c.isFunction(s) && (s = s(e)), s || s !== !1 && Fn(e.url))) {
    const l = r && o && Bn.read(o);
    l && i.set(r, l);
  }
  return e;
}, qn = typeof XMLHttpRequest < "u", In = qn && function(t) {
  return new Promise(function(n, s) {
    const r = lt(t);
    let o = r.data;
    const i = P.from(r.headers).normalize();
    let { responseType: a, onUploadProgress: u, onDownloadProgress: l } = r, f, d, b, E, h;
    function w() {
      E && E(), h && h(), r.cancelToken && r.cancelToken.unsubscribe(f), r.signal && r.signal.removeEventListener("abort", f);
    }
    let p = new XMLHttpRequest();
    p.open(r.method.toUpperCase(), r.url, !0), p.timeout = r.timeout;
    function R() {
      if (!p)
        return;
      const A = P.from(
        "getAllResponseHeaders" in p && p.getAllResponseHeaders()
      ), _ = {
        data: !a || a === "text" || a === "json" ? p.responseText : p.response,
        status: p.status,
        statusText: p.statusText,
        headers: A,
        config: t,
        request: p
      };
      at(function(j) {
        n(j), w();
      }, function(j) {
        s(j), w();
      }, _), p = null;
    }
    "onloadend" in p ? p.onloadend = R : p.onreadystatechange = function() {
      !p || p.readyState !== 4 || p.status === 0 && !(p.responseURL && p.responseURL.indexOf("file:") === 0) || setTimeout(R);
    }, p.onabort = function() {
      p && (s(new m("Request aborted", m.ECONNABORTED, t, p)), p = null);
    }, p.onerror = function() {
      s(new m("Network Error", m.ERR_NETWORK, t, p)), p = null;
    }, p.ontimeout = function() {
      let L = r.timeout ? "timeout of " + r.timeout + "ms exceeded" : "timeout exceeded";
      const _ = r.transitional || rt;
      r.timeoutErrorMessage && (L = r.timeoutErrorMessage), s(new m(
        L,
        _.clarifyTimeoutError ? m.ETIMEDOUT : m.ECONNABORTED,
        t,
        p
      )), p = null;
    }, o === void 0 && i.setContentType(null), "setRequestHeader" in p && c.forEach(i.toJSON(), function(L, _) {
      p.setRequestHeader(_, L);
    }), c.isUndefined(r.withCredentials) || (p.withCredentials = !!r.withCredentials), a && a !== "json" && (p.responseType = r.responseType), l && ([b, h] = G(l, !0), p.addEventListener("progress", b)), u && p.upload && ([d, E] = G(u), p.upload.addEventListener("progress", d), p.upload.addEventListener("loadend", E)), (r.cancelToken || r.signal) && (f = (A) => {
      p && (s(!A || A.type ? new q(null, t, p) : A), p.abort(), p = null);
    }, r.cancelToken && r.cancelToken.subscribe(f), r.signal && (r.signal.aborted ? f() : r.signal.addEventListener("abort", f)));
    const T = Un(r.url);
    if (T && O.protocols.indexOf(T) === -1) {
      s(new m("Unsupported protocol " + T + ":", m.ERR_BAD_REQUEST, t));
      return;
    }
    p.send(o || null);
  });
}, $n = (t, e) => {
  const { length: n } = t = t ? t.filter(Boolean) : [];
  if (e || n) {
    let s = new AbortController(), r;
    const o = function(l) {
      if (!r) {
        r = !0, a();
        const f = l instanceof Error ? l : this.reason;
        s.abort(f instanceof m ? f : new q(f instanceof Error ? f.message : f));
      }
    };
    let i = e && setTimeout(() => {
      i = null, o(new m(`timeout ${e} of ms exceeded`, m.ETIMEDOUT));
    }, e);
    const a = () => {
      t && (i && clearTimeout(i), i = null, t.forEach((l) => {
        l.unsubscribe ? l.unsubscribe(o) : l.removeEventListener("abort", o);
      }), t = null);
    };
    t.forEach((l) => l.addEventListener("abort", o));
    const { signal: u } = s;
    return u.unsubscribe = () => c.asap(a), u;
  }
}, Mn = function* (t, e) {
  let n = t.byteLength;
  if (n < e) {
    yield t;
    return;
  }
  let s = 0, r;
  for (; s < n; )
    r = s + e, yield t.slice(s, r), s = r;
}, Hn = async function* (t, e) {
  for await (const n of Jn(t))
    yield* Mn(n, e);
}, Jn = async function* (t) {
  if (t[Symbol.asyncIterator]) {
    yield* t;
    return;
  }
  const e = t.getReader();
  try {
    for (; ; ) {
      const { done: n, value: s } = await e.read();
      if (n)
        break;
      yield s;
    }
  } finally {
    await e.cancel();
  }
}, De = (t, e, n, s) => {
  const r = Hn(t, e);
  let o = 0, i, a = (u) => {
    i || (i = !0, s && s(u));
  };
  return new ReadableStream({
    async pull(u) {
      try {
        const { done: l, value: f } = await r.next();
        if (l) {
          a(), u.close();
          return;
        }
        let d = f.byteLength;
        if (n) {
          let b = o += d;
          n(b);
        }
        u.enqueue(new Uint8Array(f));
      } catch (l) {
        throw a(l), l;
      }
    },
    cancel(u) {
      return a(u), r.return();
    }
  }, {
    highWaterMark: 2
  });
}, ie = typeof fetch == "function" && typeof Request == "function" && typeof Response == "function", ut = ie && typeof ReadableStream == "function", zn = ie && (typeof TextEncoder == "function" ? /* @__PURE__ */ ((t) => (e) => t.encode(e))(new TextEncoder()) : async (t) => new Uint8Array(await new Response(t).arrayBuffer())), ft = (t, ...e) => {
  try {
    return !!t(...e);
  } catch {
    return !1;
  }
}, Vn = ut && ft(() => {
  let t = !1;
  const e = new Request(O.origin, {
    body: new ReadableStream(),
    method: "POST",
    get duplex() {
      return t = !0, "half";
    }
  }).headers.has("Content-Type");
  return t && !e;
}), ve = 64 * 1024, me = ut && ft(() => c.isReadableStream(new Response("").body)), X = {
  stream: me && ((t) => t.body)
};
ie && ((t) => {
  ["text", "arrayBuffer", "blob", "formData", "stream"].forEach((e) => {
    !X[e] && (X[e] = c.isFunction(t[e]) ? (n) => n[e]() : (n, s) => {
      throw new m(`Response type '${e}' is not supported`, m.ERR_NOT_SUPPORT, s);
    });
  });
})(new Response());
const Wn = async (t) => {
  if (t == null)
    return 0;
  if (c.isBlob(t))
    return t.size;
  if (c.isSpecCompliantForm(t))
    return (await new Request(O.origin, {
      method: "POST",
      body: t
    }).arrayBuffer()).byteLength;
  if (c.isArrayBufferView(t) || c.isArrayBuffer(t))
    return t.byteLength;
  if (c.isURLSearchParams(t) && (t = t + ""), c.isString(t))
    return (await zn(t)).byteLength;
}, Kn = async (t, e) => {
  const n = c.toFiniteNumber(t.getContentLength());
  return n ?? Wn(e);
}, Gn = ie && (async (t) => {
  let {
    url: e,
    method: n,
    data: s,
    signal: r,
    cancelToken: o,
    timeout: i,
    onDownloadProgress: a,
    onUploadProgress: u,
    responseType: l,
    headers: f,
    withCredentials: d = "same-origin",
    fetchOptions: b
  } = lt(t);
  l = l ? (l + "").toLowerCase() : "text";
  let E = $n([r, o && o.toAbortSignal()], i), h;
  const w = E && E.unsubscribe && (() => {
    E.unsubscribe();
  });
  let p;
  try {
    if (u && Vn && n !== "get" && n !== "head" && (p = await Kn(f, s)) !== 0) {
      let _ = new Request(e, {
        method: "POST",
        body: s,
        duplex: "half"
      }), U;
      if (c.isFormData(s) && (U = _.headers.get("content-type")) && f.setContentType(U), _.body) {
        const [j, z] = je(
          p,
          G(Fe(u))
        );
        s = De(_.body, ve, j, z);
      }
    }
    c.isString(d) || (d = d ? "include" : "omit");
    const R = "credentials" in Request.prototype;
    h = new Request(e, {
      ...b,
      signal: E,
      method: n.toUpperCase(),
      headers: f.normalize().toJSON(),
      body: s,
      duplex: "half",
      credentials: R ? d : void 0
    });
    let T = await fetch(h);
    const A = me && (l === "stream" || l === "response");
    if (me && (a || A && w)) {
      const _ = {};
      ["status", "statusText", "headers"].forEach((_e) => {
        _[_e] = T[_e];
      });
      const U = c.toFiniteNumber(T.headers.get("content-length")), [j, z] = a && je(
        U,
        G(Fe(a), !0)
      ) || [];
      T = new Response(
        De(T.body, ve, j, () => {
          z && z(), w && w();
        }),
        _
      );
    }
    l = l || "text";
    let L = await X[c.findKey(X, l) || "text"](T, t);
    return !A && w && w(), await new Promise((_, U) => {
      at(_, U, {
        data: L,
        headers: P.from(T.headers),
        status: T.status,
        statusText: T.statusText,
        config: t,
        request: h
      });
    });
  } catch (R) {
    throw w && w(), R && R.name === "TypeError" && /fetch/i.test(R.message) ? Object.assign(
      new m("Network Error", m.ERR_NETWORK, t, h),
      {
        cause: R.cause || R
      }
    ) : m.from(R, R && R.code, t, h);
  }
}), we = {
  http: un,
  xhr: In,
  fetch: Gn
};
c.forEach(we, (t, e) => {
  if (t) {
    try {
      Object.defineProperty(t, "name", { value: e });
    } catch {
    }
    Object.defineProperty(t, "adapterName", { value: e });
  }
});
const qe = (t) => `- ${t}`, Xn = (t) => c.isFunction(t) || t === null || t === !1, dt = {
  getAdapter: (t) => {
    t = c.isArray(t) ? t : [t];
    const { length: e } = t;
    let n, s;
    const r = {};
    for (let o = 0; o < e; o++) {
      n = t[o];
      let i;
      if (s = n, !Xn(n) && (s = we[(i = String(n)).toLowerCase()], s === void 0))
        throw new m(`Unknown adapter '${i}'`);
      if (s)
        break;
      r[i || "#" + o] = s;
    }
    if (!s) {
      const o = Object.entries(r).map(
        ([a, u]) => `adapter ${a} ` + (u === !1 ? "is not supported by the environment" : "is not available in the build")
      );
      let i = e ? o.length > 1 ? `since :
` + o.map(qe).join(`
`) : " " + qe(o[0]) : "as no adapter specified";
      throw new m(
        "There is no suitable adapter to dispatch the request " + i,
        "ERR_NOT_SUPPORT"
      );
    }
    return s;
  },
  adapters: we
};
function fe(t) {
  if (t.cancelToken && t.cancelToken.throwIfRequested(), t.signal && t.signal.aborted)
    throw new q(null, t);
}
function Ie(t) {
  return fe(t), t.headers = P.from(t.headers), t.data = ue.call(
    t,
    t.transformRequest
  ), ["post", "put", "patch"].indexOf(t.method) !== -1 && t.headers.setContentType("application/x-www-form-urlencoded", !1), dt.getAdapter(t.adapter || H.adapter)(t).then(function(s) {
    return fe(t), s.data = ue.call(
      t,
      t.transformResponse,
      s
    ), s.headers = P.from(s.headers), s;
  }, function(s) {
    return it(s) || (fe(t), s && s.response && (s.response.data = ue.call(
      t,
      t.transformResponse,
      s.response
    ), s.response.headers = P.from(s.response.headers))), Promise.reject(s);
  });
}
const ht = "1.7.7", Ae = {};
["object", "boolean", "number", "function", "string", "symbol"].forEach((t, e) => {
  Ae[t] = function(s) {
    return typeof s === t || "a" + (e < 1 ? "n " : " ") + t;
  };
});
const $e = {};
Ae.transitional = function(e, n, s) {
  function r(o, i) {
    return "[Axios v" + ht + "] Transitional option '" + o + "'" + i + (s ? ". " + s : "");
  }
  return (o, i, a) => {
    if (e === !1)
      throw new m(
        r(i, " has been removed" + (n ? " in " + n : "")),
        m.ERR_DEPRECATED
      );
    return n && !$e[i] && ($e[i] = !0, console.warn(
      r(
        i,
        " has been deprecated since v" + n + " and will be removed in the near future"
      )
    )), e ? e(o, i, a) : !0;
  };
};
function Qn(t, e, n) {
  if (typeof t != "object")
    throw new m("options must be an object", m.ERR_BAD_OPTION_VALUE);
  const s = Object.keys(t);
  let r = s.length;
  for (; r-- > 0; ) {
    const o = s[r], i = e[o];
    if (i) {
      const a = t[o], u = a === void 0 || i(a, o, t);
      if (u !== !0)
        throw new m("option " + o + " must be " + u, m.ERR_BAD_OPTION_VALUE);
      continue;
    }
    if (n !== !0)
      throw new m("Unknown option " + o, m.ERR_BAD_OPTION);
  }
}
const ye = {
  assertOptions: Qn,
  validators: Ae
}, N = ye.validators;
let B = class {
  constructor(e) {
    this.defaults = e, this.interceptors = {
      request: new Ue(),
      response: new Ue()
    };
  }
  /**
   * Dispatch a request
   *
   * @param {String|Object} configOrUrl The config specific for this request (merged with this.defaults)
   * @param {?Object} config
   *
   * @returns {Promise} The Promise to be fulfilled
   */
  async request(e, n) {
    try {
      return await this._request(e, n);
    } catch (s) {
      if (s instanceof Error) {
        let r;
        Error.captureStackTrace ? Error.captureStackTrace(r = {}) : r = new Error();
        const o = r.stack ? r.stack.replace(/^.+\n/, "") : "";
        try {
          s.stack ? o && !String(s.stack).endsWith(o.replace(/^.+\n.+\n/, "")) && (s.stack += `
` + o) : s.stack = o;
        } catch {
        }
      }
      throw s;
    }
  }
  _request(e, n) {
    typeof e == "string" ? (n = n || {}, n.url = e) : n = e || {}, n = D(this.defaults, n);
    const { transitional: s, paramsSerializer: r, headers: o } = n;
    s !== void 0 && ye.assertOptions(s, {
      silentJSONParsing: N.transitional(N.boolean),
      forcedJSONParsing: N.transitional(N.boolean),
      clarifyTimeoutError: N.transitional(N.boolean)
    }, !1), r != null && (c.isFunction(r) ? n.paramsSerializer = {
      serialize: r
    } : ye.assertOptions(r, {
      encode: N.function,
      serialize: N.function
    }, !0)), n.method = (n.method || this.defaults.method || "get").toLowerCase();
    let i = o && c.merge(
      o.common,
      o[n.method]
    );
    o && c.forEach(
      ["delete", "get", "head", "post", "put", "patch", "common"],
      (h) => {
        delete o[h];
      }
    ), n.headers = P.concat(i, o);
    const a = [];
    let u = !0;
    this.interceptors.request.forEach(function(w) {
      typeof w.runWhen == "function" && w.runWhen(n) === !1 || (u = u && w.synchronous, a.unshift(w.fulfilled, w.rejected));
    });
    const l = [];
    this.interceptors.response.forEach(function(w) {
      l.push(w.fulfilled, w.rejected);
    });
    let f, d = 0, b;
    if (!u) {
      const h = [Ie.bind(this), void 0];
      for (h.unshift.apply(h, a), h.push.apply(h, l), b = h.length, f = Promise.resolve(n); d < b; )
        f = f.then(h[d++], h[d++]);
      return f;
    }
    b = a.length;
    let E = n;
    for (d = 0; d < b; ) {
      const h = a[d++], w = a[d++];
      try {
        E = h(E);
      } catch (p) {
        w.call(this, p);
        break;
      }
    }
    try {
      f = Ie.call(this, E);
    } catch (h) {
      return Promise.reject(h);
    }
    for (d = 0, b = l.length; d < b; )
      f = f.then(l[d++], l[d++]);
    return f;
  }
  getUri(e) {
    e = D(this.defaults, e);
    const n = ct(e.baseURL, e.url);
    return st(n, e.params, e.paramsSerializer);
  }
};
c.forEach(["delete", "get", "head", "options"], function(e) {
  B.prototype[e] = function(n, s) {
    return this.request(D(s || {}, {
      method: e,
      url: n,
      data: (s || {}).data
    }));
  };
});
c.forEach(["post", "put", "patch"], function(e) {
  function n(s) {
    return function(o, i, a) {
      return this.request(D(a || {}, {
        method: e,
        headers: s ? {
          "Content-Type": "multipart/form-data"
        } : {},
        url: o,
        data: i
      }));
    };
  }
  B.prototype[e] = n(), B.prototype[e + "Form"] = n(!0);
});
let Zn = class pt {
  constructor(e) {
    if (typeof e != "function")
      throw new TypeError("executor must be a function.");
    let n;
    this.promise = new Promise(function(o) {
      n = o;
    });
    const s = this;
    this.promise.then((r) => {
      if (!s._listeners) return;
      let o = s._listeners.length;
      for (; o-- > 0; )
        s._listeners[o](r);
      s._listeners = null;
    }), this.promise.then = (r) => {
      let o;
      const i = new Promise((a) => {
        s.subscribe(a), o = a;
      }).then(r);
      return i.cancel = function() {
        s.unsubscribe(o);
      }, i;
    }, e(function(o, i, a) {
      s.reason || (s.reason = new q(o, i, a), n(s.reason));
    });
  }
  /**
   * Throws a `CanceledError` if cancellation has been requested.
   */
  throwIfRequested() {
    if (this.reason)
      throw this.reason;
  }
  /**
   * Subscribe to the cancel signal
   */
  subscribe(e) {
    if (this.reason) {
      e(this.reason);
      return;
    }
    this._listeners ? this._listeners.push(e) : this._listeners = [e];
  }
  /**
   * Unsubscribe from the cancel signal
   */
  unsubscribe(e) {
    if (!this._listeners)
      return;
    const n = this._listeners.indexOf(e);
    n !== -1 && this._listeners.splice(n, 1);
  }
  toAbortSignal() {
    const e = new AbortController(), n = (s) => {
      e.abort(s);
    };
    return this.subscribe(n), e.signal.unsubscribe = () => this.unsubscribe(n), e.signal;
  }
  /**
   * Returns an object that contains a new `CancelToken` and a function that, when called,
   * cancels the `CancelToken`.
   */
  static source() {
    let e;
    return {
      token: new pt(function(r) {
        e = r;
      }),
      cancel: e
    };
  }
};
function Yn(t) {
  return function(n) {
    return t.apply(null, n);
  };
}
function es(t) {
  return c.isObject(t) && t.isAxiosError === !0;
}
const be = {
  Continue: 100,
  SwitchingProtocols: 101,
  Processing: 102,
  EarlyHints: 103,
  Ok: 200,
  Created: 201,
  Accepted: 202,
  NonAuthoritativeInformation: 203,
  NoContent: 204,
  ResetContent: 205,
  PartialContent: 206,
  MultiStatus: 207,
  AlreadyReported: 208,
  ImUsed: 226,
  MultipleChoices: 300,
  MovedPermanently: 301,
  Found: 302,
  SeeOther: 303,
  NotModified: 304,
  UseProxy: 305,
  Unused: 306,
  TemporaryRedirect: 307,
  PermanentRedirect: 308,
  BadRequest: 400,
  Unauthorized: 401,
  PaymentRequired: 402,
  Forbidden: 403,
  NotFound: 404,
  MethodNotAllowed: 405,
  NotAcceptable: 406,
  ProxyAuthenticationRequired: 407,
  RequestTimeout: 408,
  Conflict: 409,
  Gone: 410,
  LengthRequired: 411,
  PreconditionFailed: 412,
  PayloadTooLarge: 413,
  UriTooLong: 414,
  UnsupportedMediaType: 415,
  RangeNotSatisfiable: 416,
  ExpectationFailed: 417,
  ImATeapot: 418,
  MisdirectedRequest: 421,
  UnprocessableEntity: 422,
  Locked: 423,
  FailedDependency: 424,
  TooEarly: 425,
  UpgradeRequired: 426,
  PreconditionRequired: 428,
  TooManyRequests: 429,
  RequestHeaderFieldsTooLarge: 431,
  UnavailableForLegalReasons: 451,
  InternalServerError: 500,
  NotImplemented: 501,
  BadGateway: 502,
  ServiceUnavailable: 503,
  GatewayTimeout: 504,
  HttpVersionNotSupported: 505,
  VariantAlsoNegotiates: 506,
  InsufficientStorage: 507,
  LoopDetected: 508,
  NotExtended: 510,
  NetworkAuthenticationRequired: 511
};
Object.entries(be).forEach(([t, e]) => {
  be[e] = t;
});
function mt(t) {
  const e = new B(t), n = ze(B.prototype.request, e);
  return c.extend(n, B.prototype, e, { allOwnKeys: !0 }), c.extend(n, e, null, { allOwnKeys: !0 }), n.create = function(r) {
    return mt(D(t, r));
  }, n;
}
const x = mt(H);
x.Axios = B;
x.CanceledError = q;
x.CancelToken = Zn;
x.isCancel = it;
x.VERSION = ht;
x.toFormData = oe;
x.AxiosError = m;
x.Cancel = x.CanceledError;
x.all = function(e) {
  return Promise.all(e);
};
x.spread = Yn;
x.isAxiosError = es;
x.mergeConfig = D;
x.AxiosHeaders = P;
x.formToJSON = (t) => ot(c.isHTMLForm(t) ? new FormData(t) : t);
x.getAdapter = dt.getAdapter;
x.HttpStatusCode = be;
x.default = x;
const {
  Axios: as,
  AxiosError: cs,
  CanceledError: ls,
  isCancel: us,
  CancelToken: fs,
  VERSION: ds,
  all: hs,
  Cancel: ps,
  isAxiosError: ms,
  spread: ws,
  toFormData: ys,
  AxiosHeaders: ts,
  HttpStatusCode: bs,
  formToJSON: gs,
  getAdapter: Es,
  mergeConfig: Rs
} = x, ns = 100, ss = 3;
class g {
  constructor({
    baseURL: e,
    link: n,
    data: s = void 0,
    searchParams: r = new URLSearchParams(),
    headers: o = new Headers()
  }) {
    y(this, "link");
    y(this, "instance");
    y(this, "searchParams");
    y(this, "data");
    y(this, "auth");
    y(this, "authenticate", async () => {
      try {
        await this.auth.checkAuthenticated();
      } catch {
        this.auth.invalidateCache(), await this.auth.loginPopup();
      }
    });
    y(this, "logout", async () => {
      await this.auth.logout(), this.auth.invalidateCache();
    });
    y(this, "getCSRFToken", async () => {
      const e = await this.instance.head(this.link.href);
      e.status === 405 && await this.instance.get(this.link.href), e.headers["x-csrf-token"] && (this.instance.defaults.headers.common["x-csrf-token"] = e.headers["x-csrf-token"]);
    });
    y(this, "setHeaders", (e) => {
      const n = new ts();
      if (e)
        for (const [s, r] of e.entries())
          n.set(s, r);
      return this.link.type ? n.set("Content-Type", `${this.link.type}+json`) : n.set("Content-Type", "application/json"), this.link.itemType && n.set("Accept", "application/vnd.sas.collection+json"), n.has("Accept") || n.set("Accept", "application/json"), n;
    });
    y(this, "setQueryParams", () => {
      !this.searchParams.has("limit") && this.link.method === "GET" && this.searchParams.append("limit", ns.toString()), this.link.method === "DELETE" && this.searchParams.delete("limit");
    });
    y(this, "execute", async () => (this.link.method !== "GET" && await this.getCSRFToken(), await this.instance({
      method: this.link.method,
      url: this.link.href,
      data: this.data,
      params: this.searchParams
    })));
    this.link = n, this.auth = new xt({
      url: e
    }), this.searchParams = r, this.setQueryParams(), this.data = s, this.instance = x.create({
      baseURL: e,
      headers: this.setHeaders(o),
      withCredentials: !0
    }), this.instance.interceptors.request.use(
      async (i) => (await this.authenticate(), i),
      (i) => Promise.reject(i)
    ), this.instance.interceptors.response.use(void 0, (i) => {
      const { response: a, config: u, message: l } = i;
      if (a.status === 405)
        return Promise.resolve(a);
      if (!(l.includes("timeout") || l.includes("Network Error")) || !u)
        return Promise.reject(i);
      if (u.retry || (u.retry = ss), a.status === 449)
        return u.retry -= 1, this.instance(u);
    });
  }
}
class J {
  constructor({ baseURL: e, info: n }) {
    y(this, "info", {});
    y(this, "baseURL");
    this.baseURL = e, this.info = n;
  }
}
const S = (t, e) => {
  const n = t.find(
    (s) => "name" in s && s.name === e || "rel" in s && s.rel === e
  );
  if (n === void 0)
    throw new Error(`Element ${e} not found`);
  return n;
}, K = ({ items: t, outputType: e = "api" }) => {
  if (t.length !== 0)
    return e === "data" ? t.map((n) => n.name) ?? [] : t;
  throw new Error("No items found");
}, Me = (t) => new Promise((e) => setTimeout(e, t)), Q = class Q extends J {
  constructor({ baseURL: e, info: n }) {
    super({ baseURL: e, info: n });
  }
};
y(Q, "getComputeContextByName", async ({ baseURL: e, contextName: n }) => {
  const s = {
    method: "GET",
    rel: "self",
    uri: "/compute/contexts",
    href: "/compute/contexts",
    type: "application/vnd.sas.collection"
  }, o = await new g({ baseURL: e, link: s }).execute();
  if (o && o.data.items) {
    const i = o.data.items, a = S(i, n);
    return new Q({ baseURL: e, info: a });
  } else
    throw new Error(`Compute context ${n} not found`);
});
let ge = Q;
const Ss = async ({ baseURL: t }) => {
  const e = {
    method: "GET",
    rel: "self",
    uri: "/compute/contexts",
    href: "/compute/contexts"
  }, s = await new g({ baseURL: t, link: e }).execute();
  if (s)
    return K({ items: s.data.items, outputType: "data" });
}, Z = class Z extends J {
  constructor({ baseURL: n, info: s }) {
    super({ baseURL: n, info: s });
    y(this, "deleteSession", async ({ logout: n = !1 }) => {
      this.info.links;
      const s = S(this.info.links, "delete"), r = new g({ baseURL: this.baseURL, link: s });
      await r.execute() && n && await r.logout();
    });
    y(this, "getLibraries", async ({ outputType: n = "data" } = {}) => {
      const s = S(this.info.links, "librefs"), o = await new g({ baseURL: this.baseURL, link: s }).execute();
      if (o)
        return K({ items: o.data.items, outputType: n });
    });
    y(this, "getLibrary", async ({ libraryName: n }) => {
      const s = await this.getLibraries({
        outputType: "api"
      }), r = S(s, n).links[0], i = await new g({ baseURL: this.baseURL, link: r }).execute();
      if (i && i.data)
        return i.data;
    });
    y(this, "getTables", async ({ libraryName: n, outputType: s = "data" }) => {
      const r = await this.getLibrary({
        libraryName: n
      });
      if (r && r.links) {
        const o = S(r.links, "tables"), i = new URLSearchParams({ limit: "1000" }), u = await new g({
          baseURL: this.baseURL,
          link: o,
          searchParams: i
        }).execute();
        if (u)
          return K({
            items: u.data.items,
            outputType: s
          });
      }
    });
    y(this, "getTable", async ({ libraryName: n, tableName: s }) => {
      const r = await this.getTables({
        libraryName: n,
        outputType: "api"
      });
      if (r) {
        const o = S(r, s).links[0], a = await new g({ baseURL: this.baseURL, link: o }).execute();
        if (a)
          return a.data;
      }
    });
    y(this, "getColumns", async ({ libraryName: n, tableName: s, outputType: r = "data" }) => {
      const o = await this.getTable({
        libraryName: n,
        tableName: s
      });
      if (o && o.links) {
        const i = S(o.links, "columns"), u = await new g({ baseURL: this.baseURL, link: i }).execute();
        if (u)
          return K({
            items: u.data.items,
            outputType: r
          });
      }
    });
    y(this, "getColumn", async ({ libraryName: n, tableName: s, columnName: r }) => {
      const o = await this.getColumns({
        libraryName: n,
        tableName: s,
        outputType: "api"
      });
      if (o) {
        const i = S(o, r).links[0], u = await new g({ baseURL: this.baseURL, link: i }).execute();
        if (u)
          return u.data;
      }
    });
    y(this, "getValues", async ({ libraryName: n, tableName: s, columnName: r, filters: o }) => {
      let i = `proc sql; create view promptValues${r} as select distinct ${r} from ${n}.${s};quit;`;
      if (o) {
        const l = this.buildWhereClause(o);
        i = `proc sql; create view promptValues${r} as select distinct ${r} from ${n}.${s} where ${l};quit;`;
      }
      const a = "j" + Math.floor(Math.random() * 1e6), u = [
        i,
        `filename ${a} temp;`,
        `proc json out=${a} pretty nokeys nosastags; export promptValues${r} ; run;`
      ];
      return await this.executeCode({ code: u, resultName: `${a}` });
    });
    y(this, "executeCode", async ({ code: n, resultName: s, params: r }) => {
      const o = {
        method: "POST",
        rel: "self",
        href: `/compute/sessions/${this.info.id}/jobs`,
        type: "application/vnd.sas.compute.job.request+json"
      }, a = await new g({
        baseURL: this.baseURL,
        link: o,
        data: { code: n },
        searchParams: r || new URLSearchParams()
      }).execute();
      if (a) {
        const u = a.data;
        let l = u.state;
        for (; ["pending", "running"].includes(l); )
          l = await this.checkJobState({ job: u });
        if (l === "completed")
          return this.getJobResult({ job: u, resultName: s });
      }
    });
    y(this, "checkJobState", async ({ job: n }) => {
      const s = S(n.links, "state"), o = await new g({ baseURL: this.baseURL, link: s }).execute();
      if (o)
        return o.data;
    });
    y(this, "getJobResult", async ({ job: n, resultName: s }) => {
      const r = S(n.links, "results"), i = await new g({ baseURL: this.baseURL, link: r }).execute();
      if (i) {
        const a = S(i.data.items, s), l = await new g({ baseURL: this.baseURL, link: a.links[0] }).execute();
        if (l) {
          const f = S(l.data.links, "content"), d = new Headers();
          d.append("Accept", f.type || "text/plain");
          const E = await new g({
            baseURL: this.baseURL,
            link: f,
            headers: d
          }).execute();
          if (E)
            return E.data;
        }
      }
    });
    y(this, "buildWhereClause", (n) => {
      if (n) {
        const s = {};
        return n.forEach((o) => {
          s[o.column] === void 0 && (s[o.column] = []), s[o.column].push(o.value);
        }), Object.keys(s).map((o) => {
          const i = s[o].map((a) => `'${a}'`);
          return `${o} in (${i.join(", ")})`;
        }).join(" and ");
      }
    });
  }
};
y(Z, "init", async ({
  baseURL: n,
  contextName: s = "SAS Job Execution compute context"
}) => {
  const r = await ge.getComputeContextByName({
    baseURL: n,
    contextName: s
  });
  if (r) {
    const o = S(r.info.links, "createSession"), a = await new g({ baseURL: n, link: o }).execute();
    if (a)
      return new Z({
        baseURL: n,
        info: a.data
      });
  }
});
let He = Z;
const Y = class Y extends J {
  constructor({ baseURL: n, info: s }) {
    super({ baseURL: n, info: s });
    y(this, "getFileContent", async () => {
      const n = S(this.info.links, "content"), r = await new g({ baseURL: this.baseURL, link: n }).execute();
      r && console.log(r.data);
    });
  }
};
y(Y, "getFileById", async ({ baseURL: n, id: s }) => {
  const r = {
    method: "GET",
    rel: "self",
    href: `/files/files/${s}`,
    uri: `/files/files/${s}`,
    type: "application/vnd.sas.file"
  }, i = await new g({ baseURL: n, link: r }).execute();
  if (i)
    return new Y({ baseURL: n, info: i.data });
});
let Ee = Y;
const ee = class ee extends J {
  constructor({ baseURL: n, info: s }) {
    super({ baseURL: n, info: s });
    y(this, "getMembers", async () => {
      const n = S(this.info.links, "members"), r = await new g({ baseURL: this.baseURL, link: n }).execute();
      if (r)
        return r.data;
    });
  }
};
y(ee, "getFolderByName", async ({
  baseURL: n,
  path: s,
  name: r
}) => {
  const o = {
    method: "GET",
    rel: "collection",
    href: "/folders/folders/@item",
    uri: "/folders/folders/@item",
    type: "application/vnd.sas.collection"
  }, i = new URLSearchParams();
  if (s)
    i.set("path", `${s}/${r}`);
  else
    throw new Error("Path is required");
  const u = await new g({ baseURL: n, link: o, searchParams: i }).execute();
  if (u)
    return new ee({ baseURL: n, info: u.data });
});
let Re = ee;
const te = class te extends J {
  constructor({ baseURL: n, info: s }) {
    super({ baseURL: n, info: s });
    y(this, "getJobDefinition", () => this.info);
    y(this, "getJobParameters", () => this.info.parameters);
    y(this, "checkJobParameters", ({ args: n }) => {
      const s = this.getJobParameters(), r = [];
      if (s)
        for (const o of s)
          !(o.name in n) && o.required && !o.defaultValue && r.push(o);
      if (r.length > 0)
        throw console.log(r), new Error("Missing parameters. Please check the console log.");
    });
    y(this, "execute", async ({ args: n, checkDelay: s, checkInterval: r, resultFileName: o }) => {
      n && this.checkJobParameters({ args: n });
      const i = {
        method: "POST",
        href: "/jobExecution/jobs",
        uri: "/jobExecution/jobs",
        type: "application/vnd.sas.job.execution.job.request",
        rel: "execute"
      }, a = S(this.info.links, "self"), l = await new g({
        baseURL: this.baseURL,
        link: i,
        data: {
          jobDefinitionUri: a.href,
          arguments: n
        }
      }).execute();
      if (l) {
        const f = l == null ? void 0 : l.data;
        let d = f.state;
        for (s && await Me(s * 1e3); ["pending", "running"].includes(d); )
          d = await this.checkJobState({ jobExecution: f }), r && await Me(r * 1e3);
        if (d === "completed")
          return o ? await this.getJobResult({
            jobExecution: f,
            resultFileName: o
          }) : f;
      }
    });
    y(this, "checkJobState", async ({ jobExecution: n }) => {
      const s = S(n.links, "state"), r = new Headers();
      r.set("Accept", "text/plain");
      const i = await new g({ baseURL: this.baseURL, link: s, headers: r }).execute();
      if (i)
        return i.data;
    });
    y(this, "getJobResult", async ({ jobExecution: n, resultFileName: s }) => {
      const r = S(n.links, "self"), i = await new g({ baseURL: this.baseURL, link: r }).execute();
      if (i && s) {
        const a = Object.keys(i.data.results).find(
          (u) => u === s
        );
        if (a) {
          const u = i.data.results[a].split("/").pop(), l = await Ee.getFileById({ baseURL: this.baseURL, id: u });
          if (l) {
            const f = S(l.info.links, "content"), b = await new g({ baseURL: this.baseURL, link: f }).execute();
            if (b)
              return b.data;
          }
        }
      }
      if (i)
        return i.data.results;
    });
  }
};
y(te, "init", async ({ baseURL: n, name: s, path: r }) => {
  const o = await Re.getFolderByName({
    baseURL: n,
    path: r.split("/").slice(0, -1).join("/"),
    name: r.split("/").slice(-1)[0]
  });
  if (o) {
    const i = await o.getMembers();
    if (i) {
      const a = S(i.items, s), u = S(a.links, "getResource"), f = await new g({
        baseURL: n,
        link: u
      }).execute();
      if (f)
        return new te({ baseURL: n, info: f.data });
      throw new Error("Failed to get job definition");
    }
  }
});
let Je = te;
export {
  ge as ComputeContext,
  He as ComputeSession,
  Je as Job,
  Ss as getComputeContexts
};
