import { AxiosResponse } from 'axios';
import { APICallProps } from '../types/APICall.types';
export default class APICall {
    private link;
    private instance;
    private searchParams;
    private data;
    private auth;
    constructor({ baseURL, link, data, searchParams, headers, }: APICallProps);
    private readonly authenticate;
    logout: () => Promise<void>;
    private readonly getCSRFToken;
    private readonly setHeaders;
    private readonly setQueryParams;
    execute: () => Promise<AxiosResponse<any, any>>;
}
